local U1Name, U1 = ...
local L = U1.L

U1RegisterAddon(U1Name, {
    title = L["Ease Addon Controller"],
    tags = { "MISC" },
    desc = L["CFG.desc"],
    protected = 1,
    icon = "Interface\\AddOns\\"..U1Name.."\\Textures\\UI2-logo",

    nopic = 1,

    author = L["CFG.author"],

    {
        text = L["Ease Addon Controller Options"], type = "text",
        {
            var = "scale",
            text = L["Main Panel Scale"],
            default = 1,
            type = "spin",
            range = { 0.5, 1.5, 0.1 },
            callback = function(cfg, v, loading)
                UUI():SetScale(v)
            end,
        },
        {
            var = "alpha",
            text = L["Main Panel Opacity"],
            default = 1,
            type = "spin",
            range = { 0.3, 1, 0.1 },
            callback = function(cfg, v, loading)
                UUI():SetAlpha(v)
            end,
        },
        {
            var = "english",
            text = L["Show AddOns Folder Name"],
            default = false,
            tip = L["Hint`Show addon folder name instead of the Title in the toc file."],
            getvalue = function() return U1GetShowOrigin() end,
            callback = function(cfg, v, loading)
                U1SetShowOrigin(v);
                if not loading then
                    U1SortAddons();
                    --UUI.Right.ADDON_SELECTED();
                end
            end,
        },
        {
            var = "sortmem",
            text = L["Sort AddOns by Memory Usage"],
            default = false,
            tip = L["Hint`Sort the addons by their memory usages instead of name order."],
            getvalue = function() return not U1DB.sortByName end,
            callback = function(cfg, v, loading)
                U1DB.sortByName = not v;
                if not loading then
                    UpdateAddOnMemoryUsage();
                    U1SortAddons()
                end
            end,
        },
    },
});